#!/usr/bin/perl
#--NetShopOwner-CGI-version:4.2.5.5--

;#
;# dbgw_relay.cgi
;# DBڑpW[
;# Copyright (c) 2004- Increment P Corp. All rights reserved
;#
;# 2009/09/30 NSO4Ή
;# 2010/02/24 Y.Motai NSO4yNSO4 ύX˗[ No.005zC
;# last modified 2010/06/25 DVC3Ή
;#

use strict;
use uselib;
use defnsopath_shop;
use NsoVersionPC 1.00;
use Lib::DbConnect;
use NsoSyncRelayCall;
use NsoCsvCapcher;
use Digest::MD5 'md5_hex';

# CX^X`
my $objConfigSystem = Config::NsoSystem->newShop();
my $objConfigMaster = Config::NsoMaster->new();

# RtBO[ṼLbV
my %ConfigSystem = $objConfigSystem->cache_config();
my %ConfigMaster = $objConfigMaster->cache_config();

my $DbConnect = Lib::DbConnect->new({ ConfigSystem=>\%ConfigSystem, ConfigMaster=>\%ConfigMaster});
my $NsoSyncRelayCall = NsoSyncRelayCall->new();
my $NsoCsvCapcher = NsoCsvCapcher->new();

#----- epX -----#
# it@C̃pX
my $goods_pass = "./nsoDB/goods/";
# ̑CSVt@C̃pX
my $csv_pass = "./nsoDB/sync/";

my $LockDir   = "./nsoDB/lock/";
my $Lock      = "dbgw_relay.cgi.lock";
# bN5
my $LockLimit = 5 * 60;
my $LockFlag  = 0;

#----- ep[^ -----#
# 敪
my $file_kbn = undef;
# t@C
my $filename1  = "file1";
my $filename2  = "file2";
my $filename3  = "file3";
my $filename4  = "file4";
my $filename5  = "file5";
my $filename6  = "file6";
# 20100625 Y.Motai start
my $filename7  = "file7";
# 20100625 Y.Motai end
my $certifykey = undef;
#------------------------#

#----- G[R[h` -----#
my $db_connect_error          = "00";		# f[^x[XڑG[
my $cliant_param_error        = "01";		# p[^ُG[
my $cliant_csv_error          = "02";		# CSVt@C݃G[
my $making_table_error        = "03";		# T[of[^x[XsG[
my $csv_analyzeing_error      = "04";		# CSVt@C̓G[
my $mk_temp_table_error       = "05";		# e|e[u쐬G[
my $goods_db_add_error        = "06";		# i񔽉fG[
my $stock_db_add_error        = "07";		# ݌ɏ񔽉fG[
my $related_db_add_error      = "08";		# ֘Ai񔽉fG[
my $art_category_db_add_error = "09";		# iJeS񔽉fG[
my $temp_rename_error         = "10";		# e|e[ũl[G[
my $member_del_error          = "11";		# ڋq폜G[
my $memberflag_modify_error   = "12";		# 敪ꊇύXG[
my $point_change_error        = "13";		# |CgύXG[
my $point_expire_error        = "14";		# |CgL؂mFG[
my $point_decision_error      = "15";		# |CgmG[
my $coupon_update_db_error    = "16";		# N[|񔽉fG[
my $member_save_error         = "17";		# ڋqۑG[
my $member_one_modify_error   = "18";		# f[^ʍXVG[
my $member_all_modify_error   = "19";		# f[^SXVG[
my $member_csv_import_error   = "20";		# ڋqCSVC|[gG[
my $variation_db_add_error    = "21";		# oG[V񔽉fG[
my $category_db_add_error     = "22";		# JeS񔽉fG[
# 20100708 Y.Motais start
my $goods_url_db_add_error    = "23";		# iڍ׃y[WpURL񔽉fG[
# 20100708 Y.Motais end
my $certification_file_error  = "96";		# F؃L[t@C݃G[
my $certification_key_error   = "97";		# F؃G[
my $duplicate_startup_error   = "98";		# dNG[
my $user_agent_error          = "99";		# [UG[WFgG[
#----------------------------#

# G[R[h
my $ErrorCode = undef;
# G[f[^
my @ErrorData;
my @ErrorData2;
# G[ڍ
my @ErrorMessage;

main();
# I
exit;


;#
;# main
;#
sub main{
#----- [UG[WFg̃`FbN -----#
	# [UG[WFg̎擾
	my $agent = $ENV{'HTTP_USER_AGENT'};
	# md5nbVÍ
	my $MD5agent = md5_hex $agent;
	# [UG[WFg̃`FbN
	if( $MD5agent ne "4f1cd31158277cbc70b5f1b434292677" ) {
		$ErrorCode = $user_agent_error;
		push(@ErrorData, "");
		push(@ErrorMessage, "ANZX܂B");
		html_out( "NG" , $ErrorCode );
	}
#----------------------------------------#

	# p[^𒊏o
	my $buffer = $ENV{'QUERY_STRING'};

	# o𕪊
	my @pairs = split( /&/, $buffer );
	foreach my $pair ( @pairs ) {
		my ( $name, $value ) = split( /=/, $pair );

		# eƂɕ
		# 敪
		if( $name eq "param" ) {
			$file_kbn = $value;
		}
		# t@C1
		elsif( $name eq "file1" ) {
			$filename1 = ($value) ? $value : "" ;
		}
		# t@C2
		elsif( $name eq "file2" ) {
			$filename2 = ($value) ? $value : "" ;
		}
		# t@C3
		elsif( $name eq "file3" ) {
			$filename3 = ($value) ? $value : "" ;
		}
		# t@C4
		elsif( $name eq "file4" ) {
			$filename4 = ($value) ? $value : "" ;
		}
		# t@C5
		elsif( $name eq "file5" ) {
			$filename5 = ($value) ? $value : "" ;
		}
		# t@C6
		elsif( $name eq "file6" ) {
			$filename6 = ($value) ? $value : "" ;
		}
		# 20100625 Y.Motai start
		# t@C7
		elsif( $name eq "file7" ) {
			$filename7 = ($value) ? $value : "" ;
		}
		# 20100625 Y.Motai end
		# F؃L[
		elsif( $name eq "key" ) {
			$certifykey = $value;
		}
	}

#----- F؃L[̃`FbN -----#
	my $KeyFilePath = "$csv_pass"."Certificationkey.log.cgi";

	# F؃L[t@C̃`FbN
	unless ( -e $KeyFilePath ){
		$ErrorCode = $certification_file_error;
		push(@ErrorData, "");
		push(@ErrorMessage, "F؃t@C܂B");
		html_out( "NG" , $ErrorCode );
	}
	# F؃L[̗L`FbN
	if( $certifykey eq undef ) {
		$ErrorCode = $certification_key_error;
		push(@ErrorData, "");
		push(@ErrorMessage, "F؃L[܂B");
		## F؃L[t@C폜
		my $ulchk = unlink($KeyFilePath);
		html_out( "NG" , $ErrorCode );
	} else {
		# F؃L[t@C̃I[v
		open(INFO, $KeyFilePath );
			my $line = <INFO>;
			chomp($line);
		close(INFO);
		# F؃L[̈v`FbN
		unless ( $certifykey eq $line ){
			$ErrorCode = $certification_key_error;
			push(@ErrorData, "");
			push(@ErrorMessage, "F؃L[słB");
			## F؃L[t@C폜
			my $ulchk = unlink($KeyFilePath);
			html_out( "NG" , $ErrorCode );
		}
		## F؃L[t@C폜
		my $ulchk = unlink($KeyFilePath);
	}
#------------------------------#
	
	# K{ڂ̃`FbNi敪j
	if ($file_kbn eq undef){
		$ErrorCode = $cliant_param_error;
		push(@ErrorData, "");
		push(@ErrorMessage, "p[^słB");
		html_out( "NG" , $ErrorCode );
	}
	#----- 敪̍ڂ̃`FbN -----#
	# ڋqۑ
	if ( $file_kbn eq "SaveCustomerInfo" ){
		# p[^łȂꍇ̓G[
		# unless ( $filename1 eq "SaveCustomerInfo.csv" && $filename2 eq "" && $filename3 eq "" && $filename4 eq "" && $filename5 eq "" && $filename6 eq "" ){
		unless ( $filename1 eq "SaveCustomerInfo.csv" && $filename2 eq "" && $filename3 eq "" && $filename4 eq "" && $filename5 eq "" && $filename6 eq "" && $filename7 eq "" ){
			$ErrorCode = $cliant_param_error;
			push(@ErrorData, "");
			push(@ErrorMessage, "p[^słB");
			html_out( "NG" , $ErrorCode );
		}
		# Kvȃt@C݂ĂȂꍇ̓G[
		unless ( -e "$csv_pass"."SaveCustomerInfo.csv" ){
			$ErrorCode = $cliant_csv_error;
			push(@ErrorData, "");
			push(@ErrorMessage, "t@C܂B");
			html_out( "NG" , $ErrorCode );
		}

		# ڋqۑ̎s
		member_save_csv_reflection();
	}
	# ڋq폜
	elsif ( $file_kbn eq "DeleteCustomerInfo" ){
		# p[^łȂꍇ̓G[
		# unless ( $filename1 eq "DeleteCustomerInfo.csv" && $filename2 eq "" && $filename3 eq "" && $filename4 eq "" && $filename5 eq "" && $filename6 eq "" ){
		unless ( $filename1 eq "DeleteCustomerInfo.csv" && $filename2 eq "" && $filename3 eq "" && $filename4 eq "" && $filename5 eq "" && $filename6 eq "" && $filename7 eq "" ){
			$ErrorCode = $cliant_param_error;
			push(@ErrorData, "");
			push(@ErrorMessage, "p[^słB");
			html_out( "NG" , $ErrorCode );
		}
		# Kvȃt@C݂ĂȂꍇ̓G[
		unless ( -e "$csv_pass"."DeleteCustomerInfo.csv" ){
			$ErrorCode = $cliant_csv_error;
			push(@ErrorData, "");
			push(@ErrorMessage, "t@C܂B");
			html_out( "NG" , $ErrorCode );
		}

		# ڋq폜̎s
		member_del_csv_reflection();
	}
	# 敪ꊇύX
	elsif ( $file_kbn eq "ChangeAllMemberFlag" ){
		# p[^łȂꍇ̓G[
		# unless ( $filename1 eq "ChangeAllMemberFlag.csv" && $filename2 eq "" && $filename3 eq "" && $filename4 eq "" && $filename5 eq "" && $filename6 eq "" ){
		unless ( $filename1 eq "ChangeAllMemberFlag.csv" && $filename2 eq "" && $filename3 eq "" && $filename4 eq "" && $filename5 eq "" && $filename6 eq "" && $filename7 eq "" ){
			$ErrorCode = $cliant_param_error;
			push(@ErrorData, "");
			push(@ErrorMessage, "p[^słB");
			html_out( "NG" , $ErrorCode );
		}
		# Kvȃt@C݂ĂȂꍇ̓G[
		unless ( -e "$csv_pass"."ChangeAllMemberFlag.csv" ){
			$ErrorCode = $cliant_csv_error;
			push(@ErrorData, "");
			push(@ErrorMessage, "t@C܂B");
			html_out( "NG" , $ErrorCode );
		}
		
		# 敪ꊇύX̎s
		member_flag_csv_reflection();
	}
	# |CgύX
	elsif ( $file_kbn eq "ChangePoint" ){
		# p[^łȂꍇ̓G[
		# unless ( $filename1 eq "ChangePoint.csv" && $filename2 eq "" && $filename3 eq "" && $filename4 eq "" && $filename5 eq "" && $filename6 eq "" ){
		unless ( $filename1 eq "ChangePoint.csv" && $filename2 eq "" && $filename3 eq "" && $filename4 eq "" && $filename5 eq "" && $filename6 eq "" && $filename7 eq "" ){
			$ErrorCode = $cliant_param_error;
			push(@ErrorData, "");
			push(@ErrorMessage, "p[^słB");
			html_out( "NG" , $ErrorCode );
		}
		# Kvȃt@C݂ĂȂꍇ̓G[
		unless ( -e "$csv_pass"."ChangePoint.csv" ){
			$ErrorCode = $cliant_csv_error;
			push(@ErrorData, "");
			push(@ErrorMessage, "t@C܂B");
			html_out( "NG" , $ErrorCode );
		}
		
		# |CgύX̎s
		change_point_csv_reflection();
	}
	# |CgL؂mF
	elsif ( $file_kbn eq "ConfirmPointExpireDate" ){
		# p[^łȂꍇ̓G[
		# unless ( $filename1 eq "ConfirmPointExpireDate.csv" && $filename2 eq "" && $filename3 eq "" && $filename4 eq "" && $filename5 eq "" && $filename6 eq "" ){
		unless ( $filename1 eq "ConfirmPointExpireDate.csv" && $filename2 eq "" && $filename3 eq "" && $filename4 eq "" && $filename5 eq "" && $filename6 eq "" && $filename7 eq "" ){
			$ErrorCode = $cliant_param_error;
			push(@ErrorData, "");
			push(@ErrorMessage, "p[^słB");
			html_out( "NG" , $ErrorCode );
		}
		# Kvȃt@C݂ĂȂꍇ̓G[
		unless ( -e "$csv_pass"."ConfirmPointExpireDate.csv" ){
			$ErrorCode = $cliant_csv_error;
			push(@ErrorData, "");
			push(@ErrorMessage, "t@C܂B");
			html_out( "NG" , $ErrorCode );
		}
		
		# |CgL؂mF̎s
		point_expire_csv_reflection();
	}
	# f[^ʍXV
	elsif ( $file_kbn eq "UpdateSeparatelyMemberData" ){
		# p[^łȂꍇ̓G[
		# unless ( $filename1 eq "UpdateSeparatelyMemberData.csv" && $filename2 eq "UpdateSeparatelyPointHistory.csv" && $filename3 eq "" && $filename4 eq "" && $filename5 eq "" && $filename6 eq "" ){
		unless ( $filename1 eq "UpdateSeparatelyMemberData.csv" && $filename2 eq "UpdateSeparatelyPointHistory.csv" && $filename3 eq "" && $filename4 eq "" && $filename5 eq "" && $filename6 eq "" && $filename7 eq "" ){
			$ErrorCode = $cliant_param_error;
			push(@ErrorData, "");
			push(@ErrorMessage, "p[^słB");
			html_out( "NG" , $ErrorCode );
		}
		# Kvȃt@C݂ĂȂꍇ̓G[
		unless ( -e "$csv_pass"."UpdateSeparatelyMemberData.csv" && -e "$csv_pass"."UpdateSeparatelyPointHistory.csv" ){
			$ErrorCode = $cliant_csv_error;
			push(@ErrorData, "");
			push(@ErrorMessage, "t@C܂B");
			html_out( "NG" , $ErrorCode );
		}

		# f[^ʍXV̎s
		member_separately_up_csv_reflection();
	}
	# f[^SXV
	elsif ( $file_kbn eq "UpdateAllMemberData" ){
		# p[^łȂꍇ̓G[
		# unless ( $filename1 eq "UpdateAllMemberData.csv" && $filename2 eq "UpdateAllPointHistory.csv" && $filename3 eq "" && $filename4 eq "" && $filename5 eq "" && $filename6 eq "" ){
		unless ( $filename1 eq "UpdateAllMemberData.csv" && $filename2 eq "UpdateAllPointHistory.csv" && $filename3 eq "" && $filename4 eq "" && $filename5 eq "" && $filename6 eq "" && $filename7 eq "" ){
			$ErrorCode = $cliant_param_error;
			push(@ErrorData, "");
			push(@ErrorMessage, "p[^słB");
			html_out( "NG" , $ErrorCode );
		}
		# Kvȃt@C݂ĂȂꍇ̓G[
		unless ( -e "$csv_pass"."UpdateAllMemberData.csv" && -e "$csv_pass"."UpdateAllPointHistory.csv" ){
			$ErrorCode = $cliant_csv_error;
			push(@ErrorData, "");
			push(@ErrorMessage, "t@C܂B");
			html_out( "NG" , $ErrorCode );
		}

		# f[^SXV̎s
		member_all_up_csv_reflection();
	}
	# ڋqCSVC|[g
	elsif ( $file_kbn eq "ImportCustomer" ){
		# p[^łȂꍇ̓G[
		# unless ( $filename1 eq "ImportCustomer.csv" && $filename2 eq "" && $filename3 eq "" && $filename4 eq "" && $filename5 eq "" && $filename6 eq "" ){
		unless ( $filename1 eq "ImportCustomer.csv" && $filename2 eq "" && $filename3 eq "" && $filename4 eq "" && $filename5 eq "" && $filename6 eq "" && $filename7 eq "" ){
			$ErrorCode = $cliant_param_error;
			push(@ErrorData, "");
			push(@ErrorMessage, "p[^słB");
			html_out( "NG" , $ErrorCode );
		}
		# Kvȃt@C݂ĂȂꍇ̓G[
		unless ( -e "$csv_pass"."ImportCustomer.csv" ){
			$ErrorCode = $cliant_csv_error;
			push(@ErrorData, "");
			push(@ErrorMessage, "t@C܂B");
			html_out( "NG" , $ErrorCode );
		}
		
		# ڋqCSVC|[g̎s
		member_import_csv_reflection();
	}
	# |Cgm
	elsif ( $file_kbn eq "DecisionPoint" ){
		# p[^łȂꍇ̓G[
		# unless ( $filename1 eq "DecisionPoint.csv" && $filename2 eq "" && $filename3 eq "" && $filename4 eq "" && $filename5 eq "" && $filename6 eq "" ){
		unless ( $filename1 eq "DecisionPoint.csv" && $filename2 eq "" && $filename3 eq "" && $filename4 eq "" && $filename5 eq "" && $filename6 eq "" && $filename7 eq "" ){
			$ErrorCode = $cliant_param_error;
			push(@ErrorData, "");
			push(@ErrorMessage, "p[^słB");
			html_out( "NG" , $ErrorCode );
		}
		# Kvȃt@C݂ĂȂꍇ̓G[
		unless ( -e "$csv_pass"."DecisionPoint.csv" ){
			$ErrorCode = $cliant_csv_error;
			push(@ErrorData, "");
			push(@ErrorMessage, "t@C܂B");
			html_out( "NG" , $ErrorCode );
		}
		
		# |Cgm̎s
		point_decision_csv_reflection();
	}
	# N[|񔽉f
	elsif ( $file_kbn eq "UploadFtpCoupon" ){
		# p[^łȂꍇ̓G[
		# unless ( $filename1 eq "UploadFtpCoupon.csv" && $filename2 eq "" && $filename3 eq "" && $filename4 eq "" && $filename5 eq "" && $filename6 eq "" ){
		unless ( $filename1 eq "UploadFtpCoupon.csv" && $filename2 eq "" && $filename3 eq "" && $filename4 eq "" && $filename5 eq "" && $filename6 eq "" && $filename7 eq "" ){
			$ErrorCode = $cliant_param_error;
			push(@ErrorData, "");
			push(@ErrorMessage, "p[^słB");
			html_out( "NG" , $ErrorCode );
		}
		# Kvȃt@C݂ĂȂꍇ̓G[
		unless ( -e "$csv_pass"."UploadFtpCoupon.csv" ){
			$ErrorCode = $cliant_csv_error;
			push(@ErrorData, "");
			push(@ErrorMessage, "t@C܂B");
			html_out( "NG" , $ErrorCode );
		}
		
		# N[|񔽉f̎s
		update_Coupon_csv_reflection();
	}
	# i񔽉f
	elsif ( $file_kbn eq "UploadFtpArticle" ){
		# p[^łȂꍇ̓G[
		# unless ( $filename1 eq "M_Goods.log.cgi" && $filename2 eq "D_GoodsStock.log.cgi" && $filename3 eq "D_GoodsRelated.log.cgi" && $filename4 eq "D_GoodsCategory.log.cgi" && $filename5 eq "D_GoodsVariation.log.cgi" && $filename6 eq "M_Category.log.cgi" ){
		unless ( $filename1 eq "M_Goods.log.cgi" && $filename2 eq "D_GoodsStock.log.cgi" && $filename3 eq "D_GoodsRelated.log.cgi" && $filename4 eq "D_GoodsCategory.log.cgi" && $filename5 eq "D_GoodsVariation.log.cgi" && $filename6 eq "M_Category.log.cgi" && $filename7 eq "D_GoodsUrl.log.cgi" ){
			$ErrorCode = $cliant_param_error;
			push(@ErrorData, "");
			push(@ErrorMessage, "p[^słB");
			html_out( "NG" , $ErrorCode );
		}
		# Kvȃt@C݂ĂȂꍇ̓G[
		# unless ( -e "$goods_pass"."M_Goods.log.cgi" &&  -e "$goods_pass"."D_GoodsStock.log.cgi" && -e "$goods_pass"."D_GoodsRelated.log.cgi" && -e "$goods_pass"."D_GoodsCategory.log.cgi" && -e "$goods_pass"."D_GoodsVariation.log.cgi" && -e "$goods_pass"."M_Category.log.cgi" ){
		unless ( -e "$goods_pass"."M_Goods.log.cgi" &&  -e "$goods_pass"."D_GoodsStock.log.cgi" && -e "$goods_pass"."D_GoodsRelated.log.cgi" && -e "$goods_pass"."D_GoodsCategory.log.cgi" && -e "$goods_pass"."D_GoodsVariation.log.cgi" && -e "$goods_pass"."M_Category.log.cgi" && -e "$goods_pass"."D_GoodsUrl.log.cgi" ){
			$ErrorCode = $cliant_csv_error;
			push(@ErrorData, "");
			push(@ErrorMessage, "t@C܂B");
			html_out( "NG" , $ErrorCode );
		}
		
		# i񔽉f̎s
		goods_csv_reflection();
	}
	# T[of[^x[X
	elsif ( $file_kbn eq "MakingTable" ){
		# p[^łȂꍇ̓G[
		# unless ( $filename1 eq "" && $filename2 eq "" && $filename3 eq "" && $filename4 eq "" && $filename5 eq "" && $filename6 eq "" ){
		unless ( $filename1 eq "" && $filename2 eq "" && $filename3 eq "" && $filename4 eq "" && $filename5 eq "" && $filename6 eq "" && $filename7 eq "" ){
			$ErrorCode = $cliant_param_error;
			push(@ErrorData, "");
			push(@ErrorMessage, "p[^słB");
			html_out( "NG" , $ErrorCode );
		}
		
		# T[of[^x[X̎s
		dbtbl_init_wks();
	}
	# ȊO
	else{
		$ErrorCode = $cliant_param_error;
			push(@ErrorData, "");
		push(@ErrorMessage, "p[^słB");
		html_out( "NG" , $ErrorCode );
	}
}


;# 
;# T[of[^x[X̎s
;# FȂ
;# ߂lFȂ
sub dbtbl_init_wks{
	
	my $self = shift;
	
	my $SQL_MakedQuery;
	my %SQL_MakedQuery;
	my $SQL_names;
	my $SQL_query;
	
	my $rows;
	
	# r`FbN (rJn)
	$LockFlag = lock_cgi();

	# NG쐬
	$SQL_MakedQuery = $NsoSyncRelayCall->make_relaymktblsQuery();
	
	# DBڑ
	my $connectError = $DbConnect->DbConnect();
	if ( $connectError ne "" ){
		push(@ErrorData, "");
		push(@ErrorMessage, "f[^x[XڑɃG[܂B");
		$ErrorCode = $db_connect_error;
		html_out( "NG" , $ErrorCode );
	}
	
	#nbVŊi[ĂSQLQoāA1{Âs
	foreach $SQL_names (sort keys %$SQL_MakedQuery ) {
		$SQL_query = $$SQL_MakedQuery{$SQL_names};
		
		#$SQL_names(nbVSQLďo)"Drop_"
		#Ă΃e[u폜AȂ΃e[u쐬
		my %db;
		if (index($SQL_names, 'Drop_',0) == 0) {
			# NGs
			%db = $DbConnect->DbTableDrop($SQL_query);
		} else {
			# NGs
			%db = $DbConnect->DbTableCreate($SQL_query);
		}
		# SQL ʎ擾
		$rows = %db->{rows};
		my $queryError = %db->{status_err};
		if ( $queryError ne "" ){
			push(@ErrorData, $SQL_names);
			push(@ErrorMessage, "SQLsɃG[܂B");
			$ErrorCode = $making_table_error;
			html_out( "NG" , $ErrorCode );
		}
	}
	# ʂ̏o
	html_out( "OK" , $ErrorCode );
}


;# 
;# i񔽉f
;# FȂ
;# ߂lFȂ
sub goods_csv_reflection{
	
	my $self = shift;
	my $SQL_MakedQuery;
	my %SQL_MakedQuery;
	my $SQL_names;
	my $SQL_query;
	my $rows;
	
	# r`FbN (rJn)
	$LockFlag = lock_cgi();

#-------------CSV
	# ͑Ȍ
	my %NsoCsvCapcher;
	my $ResultCode;
	
	# "M_Goods.log.cgi"̉
	%NsoCsvCapcher = NsoCsvCapcher->NsoCsvCapcher($goods_pass, $filename1);
	my $NsoCsvCapcher_M_Goods = %NsoCsvCapcher->{datalist};
	$ResultCode = %NsoCsvCapcher->{err_code};
	# ̓G[̏
	if ($ResultCode == 1) {
		push(@ErrorData, $filename1);
		push(@ErrorMessage, "t@C܂B");
		$ErrorCode = $csv_analyzeing_error;
		html_out( "NG" , $ErrorCode );
	}
	
	# "D_GoodsStock.log.cgi"̉
	%NsoCsvCapcher = NsoCsvCapcher->NsoCsvCapcher($goods_pass, $filename2);
	my $NsoCsvCapcher_D_GoodsStock = %NsoCsvCapcher->{datalist};
	$ResultCode = %NsoCsvCapcher->{err_code};
	# ̓G[̏
	if ($ResultCode == 1) {
		push(@ErrorData, $filename2);
		push(@ErrorMessage, "t@C܂B");
		$ErrorCode = $csv_analyzeing_error;
		html_out( "NG" , $ErrorCode );
	}
	
	# "D_GoodsRelated.log.cgi"̉
	%NsoCsvCapcher = NsoCsvCapcher->NsoCsvCapcher($goods_pass, $filename3);
	my $NsoCsvCapcher_D_GoodsRelated = %NsoCsvCapcher->{datalist};
	$ResultCode = %NsoCsvCapcher->{err_code};
	# ̓G[̏
	if ($ResultCode == 1) {
		push(@ErrorData, $filename3);
		push(@ErrorMessage, "t@C܂B");
		$ErrorCode = $csv_analyzeing_error;
		html_out( "NG" , $ErrorCode );
	}
	
	# "D_GoodsCategory.log.cgi"̉
	%NsoCsvCapcher = NsoCsvCapcher->NsoCsvCapcher($goods_pass, $filename4);
	my $NsoCsvCapcher_D_GoodsCategory = %NsoCsvCapcher->{datalist};
	$ResultCode = %NsoCsvCapcher->{err_code};
	# ̓G[̏
	if ($ResultCode == 1) {
		push(@ErrorData, $filename4);
		push(@ErrorMessage, "t@C܂B");
		$ErrorCode = $csv_analyzeing_error;
		html_out( "NG" , $ErrorCode );
	}
	
	# "D_GoodsVariation.log.cgi"̉
	%NsoCsvCapcher = NsoCsvCapcher->NsoCsvCapcher($goods_pass, $filename5);
	my $NsoCsvCapcher_D_GoodsVariation = %NsoCsvCapcher->{datalist};
	$ResultCode = %NsoCsvCapcher->{err_code};
	# ̓G[̏
	if ($ResultCode == 1) {
		push(@ErrorData, $filename5);
		push(@ErrorMessage, "t@C܂B");
		$ErrorCode = $csv_analyzeing_error;
		html_out( "NG" , $ErrorCode );
	}

	# "M_Category.log.cgi"̉
	%NsoCsvCapcher = NsoCsvCapcher->NsoCsvCapcher($goods_pass, $filename6);
	my $NsoCsvCapcher_M_Category = %NsoCsvCapcher->{datalist};
	$ResultCode = %NsoCsvCapcher->{err_code};
	# ̓G[̏
	if ($ResultCode == 1) {
		push(@ErrorData, $filename6);
		push(@ErrorMessage, "t@C܂B");
		$ErrorCode = $csv_analyzeing_error;
		html_out( "NG" , $ErrorCode );
	}
	
	# 20100625 Y.Motai start
	# "D_GoodsUrl.log.cgi"̉
	%NsoCsvCapcher = NsoCsvCapcher->NsoCsvCapcher($goods_pass, $filename7);
	my $NsoCsvCapcher_D_GoodsUrl = %NsoCsvCapcher->{datalist};
	$ResultCode = %NsoCsvCapcher->{err_code};
	# ̓G[̏
	if ($ResultCode == 1) {
		push(@ErrorData, $filename7);
		push(@ErrorMessage, "t@C܂B");
		$ErrorCode = $csv_analyzeing_error;
		html_out( "NG" , $ErrorCode );
	}
	# 20100625 Y.Motai end
#-------------

	# DBڑ(G[̎̓bZ[Wݐϊi[Areturn/SQL{G[ʂɑJ)
	my $connectError = $DbConnect->DbConnect();
	if ( $connectError ne "" ){
		push(@ErrorData, "");
		push(@ErrorMessage, "f[^x[XڑɃG[܂B");
		$ErrorCode = $db_connect_error;
		html_out( "NG" , $ErrorCode );
	}

#-------------TemporaryTable̍쐬
	# NG쐬
	$SQL_MakedQuery = $NsoSyncRelayCall->make_relaytmptblsQuery();
		
	#nbVŊi[ĂSQLQoāA1{Âs
	foreach $SQL_names (sort keys %$SQL_MakedQuery ) {

		$SQL_query = $$SQL_MakedQuery{$SQL_names};
		
		#$SQL_names(nbVSQLďo)"Drop_"
		#Ă΃e[u폜AȂ΃e[u쐬
		my %db;
		if (index($SQL_names, 'Drop_',0) == 0) {

			# NGs
			%db = $DbConnect->DbTableDrop($SQL_query);
		} else {

			# NGs
			%db = $DbConnect->DbTableCreate($SQL_query);
		}
		
		# SQL ʎ擾(G[̎̓bZ[Wݐϊi[AHtml_out)
		$rows = %db->{rows};
		my $queryError = %db->{status_err};
		if ( $queryError ne "" ){
			push(@ErrorData, $SQL_names);
			push(@ErrorMessage, "SQLsɃG[܂B");
			$ErrorCode = $mk_temp_table_error;
			html_out( "NG" , $ErrorCode );
		}
	}
#-------------

#-------------i𔽉f
	my %sqlesc = ();
	## 1sPʂł̃f[^WJEDBǉ(tB[hf[^EnbVWJ)
	foreach my $CsvCap_Line ( @$NsoCsvCapcher_M_Goods ) {
		foreach my $key ( sort keys %$CsvCap_Line ) {
			# SJISEUCGR[hGXP[v
			$sqlesc{$key} = $DbConnect->Sql_Escape_sjis2euc_decode($$CsvCap_Line{$key});
		}

		$SQL_query = $NsoSyncRelayCall->add_M_Goods_relaytmpdataQuery(\%sqlesc);
		
		# NGs
		my %db;
		%db = $DbConnect->DbInsert($SQL_query);
		
		# SQL ʎ擾(G[̎̓bZ[Wݐϊi[AHtml_out)
		$rows = %db->{rows};
		my $queryError = %db->{status_err};
		if ( $queryError ne "" ){
			push(@ErrorData, "iID[$$CsvCap_Line{ArticleID}]Fiԍ[$$CsvCap_Line{ArticleNo}]Fi[$$CsvCap_Line{ArticleName}]");
			push(@ErrorMessage, "iǉɃG[܂B");
			$ErrorCode = $goods_db_add_error;
			html_out( "NG" , $ErrorCode );
		}
	}
#-------------

#-------------݌ɏ𔽉f
	my %sqlesc2 = ();
	## 1sPʂł̃f[^WJEDBǉ(tB[hf[^EnbVWJ)
	foreach my $CsvCap_Line ( @$NsoCsvCapcher_D_GoodsStock ) {
		foreach my $key ( sort keys %$CsvCap_Line ) {
			# SJISEUCGR[hGXP[v
			$sqlesc2{$key} = $DbConnect->Sql_Escape_sjis2euc_decode($$CsvCap_Line{$key});
		}

		$SQL_query = $NsoSyncRelayCall->add_D_GoodsStock_relaytmpdataQuery(\%sqlesc2);
		
		# NGs
		my %db;
		%db = $DbConnect->DbInsert($SQL_query);
		
		# SQL ʎ擾(G[̎̓bZ[Wݐϊi[AHtml_out)
		$rows = %db->{rows};
		my $queryError = %db->{status_err};
		if ( $queryError ne "" ){
			push(@ErrorData, "iID[$$CsvCap_Line{ArticleID}]");
			push(@ErrorMessage, "݌ɏǉɃG[܂B");
			$ErrorCode = $stock_db_add_error;
			html_out( "NG" , $ErrorCode );
		}
	}
#-------------

#-------------֘Ai𔽉f
	my %sqlesc3 = ();
	## 1sPʂł̃f[^WJEDBǉ(tB[hf[^EnbVWJ)
	foreach my $CsvCap_Line ( @$NsoCsvCapcher_D_GoodsRelated ) {
		foreach my $key ( sort keys %$CsvCap_Line ) {
			# SJISEUCGR[hGXP[v
			$sqlesc3{$key} = $DbConnect->Sql_Escape_sjis2euc_decode($$CsvCap_Line{$key});
		}

		$SQL_query = $NsoSyncRelayCall->add_D_GoodsRelated_relaytmpdataQuery(\%sqlesc3);
		
		# NGs
		my %db;
		%db = $DbConnect->DbInsert($SQL_query);
		
		# SQL ʎ擾(G[̎̓bZ[Wݐϊi[AHtml_out)
		$rows = %db->{rows};
		my $queryError = %db->{status_err};
		if ( $queryError ne "" ){
			push(@ErrorData, "iID[$$CsvCap_Line{ArticleID}]F֘AiID[$$CsvCap_Line{ReletedArticleID}]");
			push(@ErrorMessage, "֘AiǉɃG[܂B");
			$ErrorCode = $related_db_add_error;
			html_out( "NG" , $ErrorCode );
		}
	}
#-------------

#-------------iJeS𔽉f
	my %sqlesc4 = ();
	## 1sPʂł̃f[^WJEDBǉ(tB[hf[^EnbVWJ)
	foreach my $CsvCap_Line ( @$NsoCsvCapcher_D_GoodsCategory ) {
		foreach my $key ( sort keys %$CsvCap_Line ) {
			# SJISEUCGR[hGXP[v
			$sqlesc4{$key} = $DbConnect->Sql_Escape_sjis2euc_decode($$CsvCap_Line{$key});
		}

		$SQL_query = $NsoSyncRelayCall->add_D_GoodsCategory_relaytmpdataQuery(\%sqlesc4);
		
		# NGs
		my %db;
		%db = $DbConnect->DbInsert($SQL_query);
		
		# SQL ʎ擾(G[̎̓bZ[Wݐϊi[AHtml_out)
		$rows = %db->{rows};
		my $queryError = %db->{status_err};
		if ( $queryError ne "" ){
			push(@ErrorData, "iID[$$CsvCap_Line{ArticleID}]FiJeSID[$$CsvCap_Line{ArticleCategoryID}]");
			push(@ErrorMessage, "JeSǉɃG[܂B");
			$ErrorCode = $art_category_db_add_error;
			html_out( "NG" , $ErrorCode );
		}
	}
#-------------

#-------------oG[V𔽉f
	my %sqlesc5 = ();
	## 1sPʂł̃f[^WJEDBǉ(tB[hf[^EnbVWJ)
	foreach my $CsvCap_Line ( @$NsoCsvCapcher_D_GoodsVariation ) {
		foreach my $key ( sort keys %$CsvCap_Line ) {
			# SJISEUCGR[hGXP[v
			$sqlesc5{$key} = $DbConnect->Sql_Escape_sjis2euc_decode($$CsvCap_Line{$key});
		}

		$SQL_query = $NsoSyncRelayCall->add_D_GoodsVariation_relaytmpdataQuery(\%sqlesc5);
		
		# NGs
		my %db;
		%db = $DbConnect->DbInsert($SQL_query);
		
		# SQL ʎ擾(G[̎̓bZ[Wݐϊi[AHtml_out)
		$rows = %db->{rows};
		my $queryError = %db->{status_err};
		if ( $queryError ne "" ){
			push(@ErrorData, "iID[$$CsvCap_Line{ArticleID}]:oG[VID[$$CsvCap_Line{VariationTypeID}]:oG[VID[$$CsvCap_Line{VariationID}]");
			push(@ErrorMessage, "oG[VǉɃG[܂B");
			$ErrorCode = $variation_db_add_error;
			html_out( "NG" , $ErrorCode );
		}
	}
#-------------

#-------------JeS𔽉f
	my %sqlesc6 = ();
	## 1sPʂł̃f[^WJEDBǉ(tB[hf[^EnbVWJ)
	foreach my $CsvCap_Line ( @$NsoCsvCapcher_M_Category ) {
		foreach my $key ( sort keys %$CsvCap_Line ) {
			# SJISEUCGR[hGXP[v
			$sqlesc6{$key} = $DbConnect->Sql_Escape_sjis2euc_decode($$CsvCap_Line{$key});
		}

		$SQL_query = $NsoSyncRelayCall->add_M_Category_relaytmpdataQuery(\%sqlesc6);
		
		# NGs
		my %db;
		%db = $DbConnect->DbInsert($SQL_query);
		
		# SQL ʎ擾(G[̎̓bZ[Wݐϊi[AHtml_out)
		$rows = %db->{rows};
		my $queryError = %db->{status_err};
		if ( $queryError ne "" ){
			push(@ErrorData, "iJeSID[$$CsvCap_Line{ArticleCategoryID}]");
			push(@ErrorMessage, "JeSǉɃG[܂B");
			$ErrorCode = $category_db_add_error;
			html_out( "NG" , $ErrorCode );
		}
	}
#-------------

# 20100625 Y.Motai start
#-------------iڍ׃y[WpURL𔽉f
	my %sqlesc7 = ();
	## 1sPʂł̃f[^WJEDBǉ(tB[hf[^EnbVWJ)
	foreach my $CsvCap_Line ( @$NsoCsvCapcher_D_GoodsUrl ) {
		foreach my $key ( sort keys %$CsvCap_Line ) {
			# SJISEUCGR[hGXP[v
			$sqlesc7{$key} = $DbConnect->Sql_Escape_sjis2euc_decode($$CsvCap_Line{$key});
		}

		$SQL_query = $NsoSyncRelayCall->add_D_ArticleDetailUrl_relaytmpdataQuery(\%sqlesc7);
		
		# NGs
		my %db;
		%db = $DbConnect->DbInsert($SQL_query);
		
		# SQL ʎ擾(G[̎̓bZ[Wݐϊi[AHtml_out)
		$rows = %db->{rows};
		my $queryError = %db->{status_err};
		if ( $queryError ne "" ){
			push(@ErrorData, "iID[$$CsvCap_Line{ArticleID}]");
			push(@ErrorMessage, "iڍ׃y[WpURLǉɃG[܂B");
			$ErrorCode = $goods_url_db_add_error;
			html_out( "NG" , $ErrorCode );
		}
	}
#-------------
# 20100625 Y.Motai end

#-------------e|e[ũl[
	# NG쐬
	$SQL_MakedQuery = $NsoSyncRelayCall->rename_relaytmptblsQuery();
		
	#nbVŊi[ĂSQLQoāA1{Âs
	foreach $SQL_names (sort keys %$SQL_MakedQuery ) {

		$SQL_query = $$SQL_MakedQuery{$SQL_names};

		# NGs
		my %db;
		%db = $DbConnect->DbRename($SQL_query);

		# SQL ʎ擾(G[̎̓bZ[Wݐϊi[AHtml_out)
		$rows = %db->{rows};
		my $queryError = %db->{status_err};
		if ( $queryError ne "" ){
			push(@ErrorData, $SQL_names);
			push(@ErrorMessage, "SQLsɃG[܂B");
			$ErrorCode = $temp_rename_error;
			html_out( "NG" , $ErrorCode );
		}
	}
#-------------

	# ʂ̏o
	html_out( "OK" , $ErrorCode );
}


;# 
;# ڋq폜
;# FȂ
;# ߂lFȂ
sub member_del_csv_reflection{
	
	my $self = shift;
	my $SQL_query;
	my $SQL_query2;
	my $rows;
	
	# r`FbN (rJn)
	$LockFlag = lock_cgi();

#-------------CSV
	# ͑Ȍ
	my %NsoCsvCapcher;
	my $ResultCode;
	
	# "DeleteCustomerInfo.csv"̉
	%NsoCsvCapcher = NsoCsvCapcher->NsoCsvCapcher($csv_pass, $filename1);
	my $NsoCsvCapcher_DeleteCustomerInfo = %NsoCsvCapcher->{datalist};
	$ResultCode = %NsoCsvCapcher->{err_code};
	# ̓G[̏
	if ($ResultCode == 1) {
		push(@ErrorData, $filename1);
		push(@ErrorMessage, "t@C܂B");
		$ErrorCode = $csv_analyzeing_error;
		html_out( "NG" , $ErrorCode );
	}
	
#-------------

	# DBڑ(G[̎̓bZ[Wݐϊi[Areturn/SQL{G[ʂɑJ)
	my $connectError = $DbConnect->DbConnect();
	if ( $connectError ne "" ){
		push(@ErrorData, "");
		push(@ErrorMessage, "f[^x[XڑɃG[܂B");
		$ErrorCode = $db_connect_error;
		html_out( "NG" , $ErrorCode );
	}


#-------------ڋqA|Cg폜
	# NG쐬
	my %sqlesc = ();
	## 1sPʂł̃f[^WJEDBǉ(tB[hf[^EnbVWJ)
	foreach my $CsvCap_Line ( @$NsoCsvCapcher_DeleteCustomerInfo ) {
		foreach my $key ( sort keys %$CsvCap_Line ) {
			# SJISEUCGR[hGXP[v
			$sqlesc{$key} = $DbConnect->Sql_Escape_sjis2euc_decode($$CsvCap_Line{$key});
		}
	#-------------ڋq폜
		$SQL_query = $NsoSyncRelayCall->Del_Customer_relayQuery(\%sqlesc);

		# NGs
		my %db;
		%db = $DbConnect->DbDelete($SQL_query);
		
		# SQL ʎ擾(G[̎̓bZ[Wݐϊi[AHtml_out)
		$rows = %db->{rows};
		my $queryError = %db->{status_err};
		if ( $queryError ne "" ){
			push(@ErrorData, "$$CsvCap_Line{SamePeriodID}");
			push(@ErrorMessage, "ڋq폜ɃG[܂B");
			$ErrorCode = $member_del_error;
		}

	#-------------|Cg폜
		$SQL_query2 = $NsoSyncRelayCall->Del_point_relayQuery(\%sqlesc);

		# NGs
		my %db2;
		%db2 = $DbConnect->DbDelete($SQL_query2);
		
		# SQL ʎ擾(G[̎̓bZ[Wݐϊi[AHtml_out)
		$rows = %db2->{rows};
		my $queryError = %db2->{status_err};
		if ( $queryError ne "" ){
			push(@ErrorData, "$$CsvCap_Line{SamePeriodID}");
			push(@ErrorMessage, "|Cg폜ɃG[܂B");
			$ErrorCode = $member_del_error;
		}
	}
#-------------

	# ʂ̏o
	if ( $ErrorCode ne "" ){
		html_out( "NG" , $ErrorCode );
	} else {
		html_out( "OK" , $ErrorCode );
	}
}


;# 
;# 敪ύX
;# FȂ
;# ߂lFȂ
sub member_flag_csv_reflection{
	
	my $self = shift;
	my $SQL_query;
	my $rows;
	
	# r`FbN (rJn)
	$LockFlag = lock_cgi();

#-------------CSV
	# ͑Ȍ
	my %NsoCsvCapcher;
	my $ResultCode;
	
	# "ChangeAllMemberFlag.csv"̉
	%NsoCsvCapcher = NsoCsvCapcher->NsoCsvCapcher($csv_pass, $filename1);
	my $NsoCsvCapcher_ChangeAllMemberFlag = %NsoCsvCapcher->{datalist};
	$ResultCode = %NsoCsvCapcher->{err_code};
	# ̓G[̏
	if ($ResultCode == 1) {
		push(@ErrorData, $filename1);
		push(@ErrorMessage, "t@C܂B");
		$ErrorCode = $csv_analyzeing_error;
		html_out( "NG" , $ErrorCode );
	}
	
#-------------

	# DBڑ(G[̎̓bZ[Wݐϊi[Areturn/SQL{G[ʂɑJ)
	my $connectError = $DbConnect->DbConnect();
	if ( $connectError ne "" ){
		push(@ErrorData, "");
		push(@ErrorMessage, "f[^x[XڑɃG[܂B");
		$ErrorCode = $db_connect_error;
		html_out( "NG" , $ErrorCode );
	}

#-------------敪ύX
	# NG쐬
	my %sqlesc = ();
	## 1sPʂł̃f[^WJEDBǉ(tB[hf[^EnbVWJ)
	foreach my $CsvCap_Line ( @$NsoCsvCapcher_ChangeAllMemberFlag ) {
		foreach my $key ( sort keys %$CsvCap_Line ) {
			# SJISEUCGR[hGXP[v
			$sqlesc{$key} = $DbConnect->Sql_Escape_sjis2euc_decode($$CsvCap_Line{$key});
		}

		$SQL_query = $NsoSyncRelayCall->Change_MemFlag_relayQuery(\%sqlesc);

		# NGs
		my %db;
		%db = $DbConnect->DbUpdate($SQL_query);
		
		# SQL ʎ擾(G[̎̓bZ[Wݐϊi[AHtml_out)
		$rows = %db->{rows};
		my $queryError = %db->{status_err};
		if ( $queryError ne "" || $rows eq '0E0'){           # '0' => '0E0'
			push(@ErrorData, "$$CsvCap_Line{SamePeriodID}");
			push(@ErrorMessage, "敪ύXɃG[܂B");
			$ErrorCode = $memberflag_modify_error;
		}
	}
#-------------

	# ʂ̏o
	if ( $ErrorCode ne "" ){
		html_out( "NG" , $ErrorCode );
	} else {
		html_out( "OK" , $ErrorCode );
	}
}


;# 
;# |CgύX
;# FȂ
;# ߂lFȂ
sub change_point_csv_reflection{
	
	my $self = shift;
	my $SQL_query;
	my $SQL_query2;
	my $SQL_query3;
	my $SQL_query4;
	my $rows;
	my $RecordList;
	my $RecordCount;
	
	# r`FbN (rJn)
	$LockFlag = lock_cgi();

#-------------CSV
	# ͑Ȍ
	my %NsoCsvCapcher;
	my $ResultCode;
	
	# "ChangePoint.csv"̉
	%NsoCsvCapcher = NsoCsvCapcher->NsoCsvCapcher($csv_pass, $filename1);
	my $NsoCsvCapcher_ChangePoint = %NsoCsvCapcher->{datalist};
	$ResultCode = %NsoCsvCapcher->{err_code};
	# ̓G[̏
	if ($ResultCode == 1) {
		push(@ErrorData, $filename1);
		push(@ErrorMessage, "t@C܂B");
		$ErrorCode = $csv_analyzeing_error;
		html_out( "NG" , $ErrorCode );
	}
	
#-------------

	# DBڑ(G[̎̓bZ[Wݐϊi[Areturn/SQL{G[ʂɑJ)
	my $connectError = $DbConnect->DbConnect();
	if ( $connectError ne "" ){
		push(@ErrorData, "");
		push(@ErrorMessage, "f[^x[XڑɃG[܂B");
		$ErrorCode = $db_connect_error;
		html_out( "NG" , $ErrorCode );
	}

#-------------|CgύXA|Cgǉ
	# NG쐬
	my %sqlesc = ();
	## 1sPʂł̃f[^WJEDBǉ(tB[hf[^EnbVWJ)
	foreach my $CsvCap_Line ( @$NsoCsvCapcher_ChangePoint ) {
		foreach my $key ( sort keys %$CsvCap_Line ) {
			# SJISEUCGR[hGXP[v
			$sqlesc{$key} = $DbConnect->Sql_Escape_sjis2euc_decode($$CsvCap_Line{$key});
		}
	#-------------|CgύX
		# NGs
		$SQL_query = $NsoSyncRelayCall->Change_Point_relayQuery(\%sqlesc);

		my %db;
		%db = $DbConnect->DbUpdate($SQL_query);
		
		# SQL ʎ擾(G[̎̓bZ[Wݐϊi[AHtml_out)
		$rows = %db->{rows};
		my $queryError = %db->{status_err};
		if ( $queryError ne "" || $rows eq '0E0'){           # '0' => '0E0'
			push(@ErrorData, "$$CsvCap_Line{SamePeriodID}");
			push(@ErrorMessage, "|CgύXɃG[܂B");
			$ErrorCode = $point_change_error;
		} else {

		#-------------|Cgǉ([|CgύX]NGɎsꂽꍇ̂)

			my %RecordHash2 = (
				ChangeTime				=>	$sqlesc{'ChangeTime'},		# ύX
				SamePeriodID			=>	$sqlesc{'SamePeriodID'},	# ID
				ChangeType				=>	$sqlesc{'ChangeType'},		# ύX敪
				ChangePoint				=>	$sqlesc{'ChangePoint'},		# ύX|Cg
			);

			$SQL_query2 = $NsoSyncRelayCall->Point_add_relayQuery(\%RecordHash2);

			my %db2;
			%db2 = $DbConnect->DbInsert($SQL_query2);
			
			# SQL ʎ擾(G[̎̓bZ[Wݐϊi[AHtml_out)
			$rows = %db2->{rows};
			my $queryError = %db2->{status_err};
			if ( $queryError ne "" || $rows eq '0E0'){           # '0' => '0E0'
				push(@ErrorData, "$$CsvCap_Line{SamePeriodID}");
				push(@ErrorMessage, "|CgǉɃG[܂B");
				$ErrorCode = $point_change_error;
			}

		#-------------|Cg擾
			
			my %RecordHash3 = (
				SamePeriodID			=>	$sqlesc{'SamePeriodID'},	# ID
			);
			
			# NGs
			$SQL_query3 = $NsoSyncRelayCall->Point_select_relayQuery(\%RecordHash3);

			my %db3;
			%db3 = $DbConnect->DbSelect($SQL_query3);

			# SQL ʎ擾(G[̎̓bZ[Wݐϊi[AHtml_out)
			my $queryError = %db3->{status_err};
			if ( $queryError ne ""){
				push(@ErrorData, "$$CsvCap_Line{SamePeriodID}");
				push(@ErrorMessage, "|Cg擾ɃG[܂B");
				$ErrorCode = $point_change_error;
			}
			
		#-------------|Cg폜(|Cg6ȏ̏ꍇ)
			$RecordList = %db3->{RecordList};
			$RecordCount = scalar @$RecordList;

			if ( $RecordCount > 5){

				my $i = 1;
				foreach my $Record (@{$RecordList}){
					my $cnt = 0;
					# DB擾f[^EUCȂ̂ŁAfR[hȂGXP[v
					my %RecordHash = (
						ChangeTime					=>	$DbConnect->Sql_Escape_non_decode($$Record[$cnt++]),		# ύX
						SamePeriodID				=>	$DbConnect->Sql_Escape_non_decode($$Record[$cnt++]),		# ID
						ChangePoint					=>	$DbConnect->Sql_Escape_non_decode($$Record[$cnt++]),		# ύX|Cg
						ChangeType					=>	$DbConnect->Sql_Escape_non_decode($$Record[$cnt++]),		# ύX敪
						);
				# 6Ԗڂ폜
					if($i > 5 ) {
						$SQL_query4 = $NsoSyncRelayCall->Point_delete_relayQuery(\%RecordHash);

						my %db4;
						%db4 = $DbConnect->DbDelete($SQL_query4);

					# SQL ʎ擾(G[̎̓bZ[Wݐϊi[AHtml_out)
						$rows = %db->{rows};
						my $queryError = %db4->{status_err};
						if ( $queryError ne "" || $rows eq '0E0'){           # '0' => '0E0'
							push(@ErrorData, "$$CsvCap_Line{SamePeriodID}");
							push(@ErrorMessage, "|Cg폜ɃG[܂B");
							$ErrorCode = $point_change_error;
						}
					}
				$i++;
				}
			}
		}
	}

#-------------

	# ʂ̏o
	if ( $ErrorCode ne "" ){
		html_out( "NG" , $ErrorCode );
	} else {
		html_out( "OK" , $ErrorCode );
	}
}


;# 
;# |CgL؂XV
;# FȂ
;# ߂lFȂ
sub point_expire_csv_reflection{
	
	my $self = shift;
	my $SQL_query;
	my $SQL_query2;
	my $SQL_query3;
	my $SQL_query4;
	my $rows;
	my $RecordList;
	my $RecordCount;
	
	# r`FbN (rJn)
	$LockFlag = lock_cgi();

#-------------CSV
	# ͑Ȍ
	my %NsoCsvCapcher;
	my $ResultCode;
	
	# "ConfirmPointExpireDate.csv"̉
	%NsoCsvCapcher = NsoCsvCapcher->NsoCsvCapcher($csv_pass, $filename1);
	my $NsoCsvCapcher_ExpirePoint = %NsoCsvCapcher->{datalist};
	$ResultCode = %NsoCsvCapcher->{err_code};
	# ̓G[̏
	if ($ResultCode == 1) {
		push(@ErrorData, $filename1);
		push(@ErrorMessage, "t@C܂B");
		$ErrorCode = $csv_analyzeing_error;
		html_out( "NG" , $ErrorCode );
	}
	
#-------------

	# DBڑ(G[̎̓bZ[Wݐϊi[Areturn/SQL{G[ʂɑJ)
	my $connectError = $DbConnect->DbConnect();
	if ( $connectError ne "" ){
		push(@ErrorData, "");
		push(@ErrorMessage, "f[^x[XڑɃG[܂B");
		$ErrorCode = $db_connect_error;
		html_out( "NG" , $ErrorCode );
	}

#-------------|CgL؂XVA|Cgǉ
	# NG쐬
	my %sqlesc = ();
	## 1sPʂł̃f[^WJEDBǉ(tB[hf[^EnbVWJ)
	foreach my $CsvCap_Line ( @$NsoCsvCapcher_ExpirePoint ) {
		foreach my $key ( sort keys %$CsvCap_Line ) {
			# SJISEUCGR[hGXP[v
			$sqlesc{$key} = $DbConnect->Sql_Escape_sjis2euc_decode($$CsvCap_Line{$key});
		}
	#-------------|CgL؂XV
		# NGs
		$SQL_query = $NsoSyncRelayCall->Change_Expire_Point_relayQuery(\%sqlesc);

		my %db;
		%db = $DbConnect->DbUpdate($SQL_query);
		
		# SQL ʎ擾(G[̎̓bZ[Wݐϊi[AHtml_out)
		$rows = %db->{rows};
		my $queryError = %db->{status_err};
		if ( $queryError ne "" || $rows eq '0E0'){           # '0' => '0E0'
			push(@ErrorData, "$$CsvCap_Line{SamePeriodID}");
			push(@ErrorMessage, "|CgL؂mFɃG[܂B");
			$ErrorCode = $point_expire_error;
		} else {

		#-------------|Cgǉ([|CgL؂XV]NGɎsꂽꍇ̂)

			my %RecordHash2 = (
				SamePeriodID			=>	$sqlesc{'SamePeriodID'},					# ID
				ChangeTime				=>	$sqlesc{'PointExpireDate'},					# |CgL
				ChangeType				=>	$sqlesc{'ChangeType'},						# ύX敪
				ChangePoint				=>	$DbConnect->Sql_Escape_sjis2euc_decode(0),	# ύX|Cg(SJISEUCGR[hGXP[v)
			);

			$SQL_query2 = $NsoSyncRelayCall->Point_add_relayQuery(\%RecordHash2);

			my %db2;
			%db2 = $DbConnect->DbInsert($SQL_query2);
			
			# SQL ʎ擾(G[̎̓bZ[Wݐϊi[AHtml_out)
			$rows = %db2->{rows};
			my $queryError = %db2->{status_err};
			if ( $queryError ne "" || $rows eq '0E0'){           # '0' => '0E0'
				push(@ErrorData, "$$CsvCap_Line{SamePeriodID}" );
				push(@ErrorMessage, "|CgǉɃG[܂B");
				$ErrorCode = $point_expire_error;
			}

		#-------------|Cg擾
			
			my %RecordHash3 = (
				SamePeriodID			=>	$sqlesc{'SamePeriodID'},	# ID
			);
			
			# NGs
			$SQL_query3 = $NsoSyncRelayCall->Point_select_relayQuery(\%RecordHash3);

			my %db3;
			%db3 = $DbConnect->DbSelect($SQL_query3);

			# SQL ʎ擾(G[̎̓bZ[Wݐϊi[AHtml_out)
			my $queryError = %db3->{status_err};
			if ( $queryError ne ""){
				push(@ErrorData, "$$CsvCap_Line{SamePeriodID}");
				push(@ErrorMessage, "|Cg擾ɃG[܂B");
				$ErrorCode = $point_expire_error;
			}
			
		#-------------|Cg폜(|Cg6ȏ̏ꍇ)
			$RecordList = %db3->{RecordList};
			$RecordCount = scalar @$RecordList;

			if ( $RecordCount > 5){

				my $i = 1;
				foreach my $Record (@{$RecordList}){
					my $cnt = 0;
					# DB擾f[^EUCȂ̂ŁAfR[hȂGXP[v
					my %RecordHash = (
						ChangeTime					=>	$DbConnect->Sql_Escape_non_decode($$Record[$cnt++]),	# ύX
						SamePeriodID				=>	$DbConnect->Sql_Escape_non_decode($$Record[$cnt++]),	# ID
						ChangePoint					=>	$DbConnect->Sql_Escape_non_decode($$Record[$cnt++]),	# ύX|Cg
						ChangeType					=>	$DbConnect->Sql_Escape_non_decode($$Record[$cnt++]),	# ύX敪
						);
				# 6Ԗڂ폜
					if($i > 5 ) {
						$SQL_query4 = $NsoSyncRelayCall->Point_delete_relayQuery(\%RecordHash);

						my %db4;
						%db4 = $DbConnect->DbDelete($SQL_query4);

					# SQL ʎ擾(G[̎̓bZ[Wݐϊi[AHtml_out)
						$rows = %db->{rows};
						my $queryError = %db4->{status_err};
						if ( $queryError ne "" || $rows eq '0E0'){           # '0' => '0E0'
							push(@ErrorData, "$$CsvCap_Line{SamePeriodID}");
							push(@ErrorMessage, "|Cg폜ɃG[܂B");
							$ErrorCode = $point_expire_error;
						}
					}
				$i++;
				}
			}
		}
	}

#-------------

	# ʂ̏o
	if ( $ErrorCode ne "" ){
		html_out( "NG" , $ErrorCode );
	} else {
		html_out( "OK" , $ErrorCode );
	}
}


;# 
;# |Cgm
;# FȂ
;# ߂lFȂ
sub point_decision_csv_reflection{
	
	my $self = shift;
	my $SQL_query;
	my $SQL_query2;
	my $SQL_query3;
	my $SQL_query4;
	my $rows;
	my $RecordList;
	my $RecordCount;
	
	# r`FbN (rJn)
	$LockFlag = lock_cgi();

#-------------CSV
	# ͑Ȍ
	my %NsoCsvCapcher;
	my $ResultCode;
	
	# "DecisionPoint.csv"̉
	%NsoCsvCapcher = NsoCsvCapcher->NsoCsvCapcher($csv_pass, $filename1);
	my $NsoCsvCapcher_DecisionPoint = %NsoCsvCapcher->{datalist};
	$ResultCode = %NsoCsvCapcher->{err_code};
	# ̓G[̏
	if ($ResultCode == 1) {
		push(@ErrorData, $filename1);
		push(@ErrorMessage, "t@C܂B");
		$ErrorCode = $csv_analyzeing_error;
		html_out( "NG" , $ErrorCode );
	}
	
#-------------

	# DBڑ(G[̎̓bZ[Wݐϊi[Areturn/SQL{G[ʂɑJ)
	my $connectError = $DbConnect->DbConnect();
	if ( $connectError ne "" ){
		push(@ErrorData, "");
		push(@ErrorMessage, "f[^x[XڑɃG[܂B");
		$ErrorCode = $db_connect_error;
		html_out( "NG" , $ErrorCode );
	}

#-------------|CgmA|Cgǉ
	# NG쐬
	my %sqlesc = ();
	## 1sPʂł̃f[^WJEDBǉ(tB[hf[^EnbVWJ)
	foreach my $CsvCap_Line ( @$NsoCsvCapcher_DecisionPoint ) {
		foreach my $key ( sort keys %$CsvCap_Line ) {
			# SJISEUCGR[hGXP[v
			$sqlesc{$key} = $DbConnect->Sql_Escape_sjis2euc_decode($$CsvCap_Line{$key});
		}
	#-------------|Cgm
		# NGs
		$SQL_query = $NsoSyncRelayCall->Change_Decision_Point_relayQuery(\%sqlesc);

		my %db;
		%db = $DbConnect->DbUpdate($SQL_query);
		
		# SQL ʎ擾(G[̎̓bZ[Wݐϊi[AHtml_out)
		$rows = %db->{rows};
		my $queryError = %db->{status_err};
		if ( $queryError ne "" || $rows eq '0E0'){           # '0' => '0E0'
			push(@ErrorData, "$$CsvCap_Line{OrderNo}");
			push(@ErrorMessage, "|Cgm蒆ɃG[܂B");
			$ErrorCode = $point_decision_error;
		} else {

		#-------------|Cgǉ([|Cgm]NGɎsꂽꍇ̂)

			my %RecordHash2 = (
				SamePeriodID			=>	$sqlesc{'SamePeriodID'},	# ID
				ChangeTime				=>	$sqlesc{'ChangeTime'},		# s(ύX)
				ChangeType				=>	$sqlesc{'ChangeType'},		# ύX敪
				ChangePoint				=>	$sqlesc{'ChangePoint'},		# ύX|Cg
			);

			$SQL_query2 = $NsoSyncRelayCall->Point_add_relayQuery(\%RecordHash2);

			my %db2;
			%db2 = $DbConnect->DbInsert($SQL_query2);
			
			# SQL ʎ擾(G[̎̓bZ[Wݐϊi[AHtml_out)
			$rows = %db2->{rows};
			my $queryError = %db2->{status_err};
			if ( $queryError ne "" || $rows eq '0E0'){           # '0' => '0E0'
				push(@ErrorData, "$$CsvCap_Line{OrderNo}" );
				push(@ErrorMessage, "|CgǉɃG[܂B");
				$ErrorCode = $point_decision_error;
			}

		#-------------|Cg擾
			
			my %RecordHash3 = (
				SamePeriodID			=>	$sqlesc{'SamePeriodID'},	# ID
			);
			
			# NGs
			$SQL_query3 = $NsoSyncRelayCall->Point_select_relayQuery(\%RecordHash3);

			my %db3;
			%db3 = $DbConnect->DbSelect($SQL_query3);

			# SQL ʎ擾(G[̎̓bZ[Wݐϊi[AHtml_out)
			my $queryError = %db3->{status_err};
			if ( $queryError ne ""){
				push(@ErrorData, "$$CsvCap_Line{OrderNo}");
				push(@ErrorMessage, "|Cg擾ɃG[܂B");
				$ErrorCode = $point_decision_error;
			}
			
		#-------------|Cg폜(|Cg6ȏ̏ꍇ)
			$RecordList = %db3->{RecordList};
			$RecordCount = scalar @$RecordList;

			if ( $RecordCount > 5){

				my $i = 1;
				foreach my $Record (@{$RecordList}){
					my $cnt = 0;
					# DB擾f[^EUCȂ̂ŁAfR[hȂGXP[v
					my %RecordHash = (
						ChangeTime					=>	$DbConnect->Sql_Escape_non_decode($$Record[$cnt++]),	# ύX
						SamePeriodID				=>	$DbConnect->Sql_Escape_non_decode($$Record[$cnt++]),	# ID
						ChangePoint					=>	$DbConnect->Sql_Escape_non_decode($$Record[$cnt++]),	# ύX|Cg
						ChangeType					=>	$DbConnect->Sql_Escape_non_decode($$Record[$cnt++]),	# ύX敪
						);
				# 6Ԗڂ폜
					if($i > 5 ) {
						$SQL_query4 = $NsoSyncRelayCall->Point_delete_relayQuery(\%RecordHash);

						my %db4;
						%db4 = $DbConnect->DbDelete($SQL_query4);

					# SQL ʎ擾(G[̎̓bZ[Wݐϊi[AHtml_out)
						$rows = %db->{rows};
						my $queryError = %db4->{status_err};
						if ( $queryError ne "" || $rows eq '0E0'){           # '0' => '0E0'
							push(@ErrorData, "$$CsvCap_Line{OrderNo}");
							push(@ErrorMessage, "|Cg폜ɃG[܂B");
							$ErrorCode = $point_decision_error;
						}
					}
				$i++;
				}
			}
		}
	}
#-------------

	# ʂ̏o
	if ( $ErrorCode ne "" ){
		html_out( "NG" , $ErrorCode );
	} else {
		html_out( "OK" , $ErrorCode );
	}
}


;# 
;# N[|񔽉f
;# FȂ
;# ߂lFȂ
sub update_Coupon_csv_reflection{
	
	my $self = shift;
	my $SQL_query;
	my $SQL_MakedQuery;
	my $SQL_names;
	my $rows;
	
	# r`FbN (rJn)
	$LockFlag = lock_cgi();

#-------------CSV
	# ͑Ȍ
	my %NsoCsvCapcher;
	my $ResultCode;
	
	# "UploadFtpCoupon.csv"̉
	%NsoCsvCapcher = NsoCsvCapcher->NsoCsvCapcher($csv_pass, $filename1);
	my $NsoCsvCapcher_UploadCoupon = %NsoCsvCapcher->{datalist};
	$ResultCode = %NsoCsvCapcher->{err_code};
	# ̓G[̏
	if ($ResultCode == 1) {
		push(@ErrorData, $filename1);
		push(@ErrorMessage, "t@C܂B");
		$ErrorCode = $csv_analyzeing_error;
		html_out( "NG" , $ErrorCode );
	}
	
#-------------

	# DBڑ(G[̎̓bZ[Wݐϊi[Areturn/SQL{G[ʂɑJ)
	my $connectError = $DbConnect->DbConnect();
	if ( $connectError ne "" ){
		push(@ErrorData, "");
		push(@ErrorMessage, "f[^x[XڑɃG[܂B");
		$ErrorCode = $db_connect_error;
		html_out( "NG" , $ErrorCode );
	}

#-------------N[|񔽉f
	# NG쐬
	my %sqlesc = ();
	## 1sPʂł̃f[^WJEDBǉ(tB[hf[^EnbVWJ)
	foreach my $CsvCap_Line ( @$NsoCsvCapcher_UploadCoupon ) {
		foreach my $key ( sort keys %$CsvCap_Line ) {
			# SJISEUCGR[hGXP[v
			$sqlesc{$key} = $DbConnect->Sql_Escape_sjis2euc_decode($$CsvCap_Line{$key});
		}

		$SQL_MakedQuery = $NsoSyncRelayCall->Update_Coupon_relayQuery(\%sqlesc);

		#nbVŊi[ĂSQLQoāA1{Âs
		foreach $SQL_names (sort keys %$SQL_MakedQuery ) {
			$SQL_query = $$SQL_MakedQuery{$SQL_names};

			#$SQL_names(nbVSQLďo)"Delete_"Ă΍폜ȂΒǉ
			my %db;
			if (index($SQL_names, 'Delete_',0) == 0) {

				# NGs
				%db = $DbConnect->DbDelete($SQL_query);
				
				# SQL ʎ擾(G[̎̓bZ[Wݐϊi[AHtml_out)
				$rows = %db->{rows};
				my $queryError = %db->{status_err};
				if ( $queryError ne "" ){
					push(@ErrorData, "No.$$CsvCap_Line{CouponNo}");
					push(@ErrorMessage, "N[|폜ɃG[܂B");
					$ErrorCode = $coupon_update_db_error;
				}
			} else {

				# NGs
				%db = $DbConnect->DbInsert($SQL_query);

				# SQL ʎ擾(G[̎̓bZ[Wݐϊi[AHtml_out)
				$rows = %db->{rows};
				my $queryError = %db->{status_err};
				if ( $queryError ne "" || $rows eq '0E0'){           # '0' => '0E0'
					push(@ErrorData, "No.$$CsvCap_Line{CouponNo}");
					push(@ErrorMessage, "N[|ǉɃG[܂B");
					$ErrorCode = $coupon_update_db_error;
				}
			}
		}
	}
#-------------

	# ʂ̏o
	if ( $ErrorCode ne "" ){
		html_out( "NG" , $ErrorCode );
	} else {
		html_out( "OK" , $ErrorCode );
	}
}


;# 
;# ڋqۑ
;# FȂ
;# ߂lFȂ
sub member_save_csv_reflection{
	
	my $self = shift;
	my $SQL_query;
	my $rows;
	
	# r`FbN (rJn)
	$LockFlag = lock_cgi();

#-------------CSV
	# ͑Ȍ
	my %NsoCsvCapcher;
	my $ResultCode;

	# "SaveCustomerInfo.csv"̉
	%NsoCsvCapcher = NsoCsvCapcher->NsoCsvCapcherDecode($csv_pass, $filename1);
	my $NsoCsvCapcher_SaveCustomerInfo = %NsoCsvCapcher->{datalist};
	$ResultCode = %NsoCsvCapcher->{err_code};
	# ̓G[̏
	if ($ResultCode == 1) {
		push(@ErrorData, $filename1);
		push(@ErrorMessage, "t@C܂B");
		$ErrorCode = $csv_analyzeing_error;
		html_out( "NG" , $ErrorCode );
	} 
	
#-------------

	# DBڑ(G[̎̓bZ[Wݐϊi[Areturn/SQL{G[ʂɑJ)
	my $connectError = $DbConnect->DbConnect();
	if ( $connectError ne "" ){
		push(@ErrorData, "");
		push(@ErrorMessage, "f[^x[XڑɃG[܂B");
		$ErrorCode = $db_connect_error;
		html_out( "NG" , $ErrorCode );
	}

#-------------ڋqۑ
	# NG쐬
	my %sqlesc = ();
	## 1sPʂł̃f[^WJEDBǉ(tB[hf[^EnbVWJ)
	foreach my $CsvCap_Line ( @$NsoCsvCapcher_SaveCustomerInfo ) {
		foreach my $key ( sort keys %$CsvCap_Line ) {
			# SJISEUCGR[hGXP[v
			$sqlesc{$key} = $DbConnect->Sql_Escape_sjis2euc_decode($$CsvCap_Line{$key});
		}

		$SQL_query = $NsoSyncRelayCall->Change_member_info_relayQuery(\%sqlesc);

		# NGs
		my %db;
		%db = $DbConnect->DbUpdate($SQL_query);
		# SQL ʎ擾(G[̎̓bZ[Wݐϊi[AHtml_out)
		$rows = %db->{rows};
		my $queryError = %db->{status_err};
		if ( $queryError ne "" || $rows eq '0E0'){           # '0' => '0E0'
			push(@ErrorData, "$$CsvCap_Line{SamePeriodID}");
			push(@ErrorMessage, "ڋqXVɃG[܂B");
			$ErrorCode = $member_save_error;
		}
	}
#-------------

	# ʂ̏o
	if ( $ErrorCode ne "" ){
		html_out( "NG" , $ErrorCode );
	} else {
		html_out( "OK" , $ErrorCode );
	}
}


;# 
;# ڋqCSVC|[g
;# FȂ
;# ߂lFȂ
sub member_import_csv_reflection{
	
	my $self = shift;
	my $SQL_query;
	my $rows;
	
	# r`FbN (rJn)
	$LockFlag = lock_cgi();

#-------------CSV
	# ͑Ȍ
	my %NsoCsvCapcher;
	my $ResultCode;

	# "ImportCustomer.csv"̉
	%NsoCsvCapcher = NsoCsvCapcher->NsoCsvCapcherDecode($csv_pass, $filename1);
	my $NsoCsvCapcher_ImportCustomer = %NsoCsvCapcher->{datalist};
	$ResultCode = %NsoCsvCapcher->{err_code};
	# ̓G[̏
	if ($ResultCode == 1) {
		push(@ErrorData, $filename1);
		push(@ErrorMessage, "t@C܂B");
		$ErrorCode = $csv_analyzeing_error;
		html_out( "NG" , $ErrorCode );
	}
	
#-------------

	# DBڑ(G[̎̓bZ[Wݐϊi[Areturn/SQL{G[ʂɑJ)
	my $connectError = $DbConnect->DbConnect();
	if ( $connectError ne "" ){
		push(@ErrorData, "");
		push(@ErrorMessage, "f[^x[XڑɃG[܂B");
		$ErrorCode = $db_connect_error;
		html_out( "NG" , $ErrorCode );
	}

#-------------ڋqCSVC|[g
	# NG쐬
	my %sqlesc = ();
	## 1sPʂł̃f[^WJEDBǉ(tB[hf[^EnbVWJ)
	foreach my $CsvCap_Line ( @$NsoCsvCapcher_ImportCustomer ) {
		foreach my $key ( sort keys %$CsvCap_Line ) {
			# SJISEUCGR[hGXP[v
			$sqlesc{$key} = $DbConnect->Sql_Escape_sjis2euc_decode($$CsvCap_Line{$key});
		}

		$SQL_query = $NsoSyncRelayCall->Member_csv_import_relayQuery(\%sqlesc);

		# NGs
		my %db;
		%db = $DbConnect->DbUpdate($SQL_query);
		# SQL ʎ擾(G[̎̓bZ[Wݐϊi[AHtml_out)
		$rows = %db->{rows};
		my $queryError = %db->{status_err};
		if ( $queryError ne "" || $rows eq '0E0'){           # '0' => '0E0'
			push(@ErrorData, "$$CsvCap_Line{SamePeriodID}");
			push(@ErrorMessage, "ڋqXVɃG[܂B");
			$ErrorCode = $member_csv_import_error;
		}
	}
#-------------

	# ʂ̏o
	if ( $ErrorCode ne "" ){
		html_out( "NG" , $ErrorCode );
	} else {
		html_out( "OK" , $ErrorCode );
	}
}


;# 
;# f[^ʍXV
;# FȂ
;# ߂lFȂ
sub member_separately_up_csv_reflection{
	
	my $self = shift;
	my $SQL_query;
	my $SQL_query2;
	my $SQL_query3;
	my $SQL_query4;
	my $rows;
	
	# r`FbN (rJn)
	$LockFlag = lock_cgi();

#-------------CSV
	# ͑Ȍ
	my %NsoCsvCapcher;
	my $ResultCode;

	# "UpdateSeparatelyMemberData.csv"̉
	%NsoCsvCapcher = NsoCsvCapcher->NsoCsvCapcherDecode($csv_pass, $filename1);
	my $NsoCsvCapcher_UpSeparateMember = %NsoCsvCapcher->{datalist};
	$ResultCode = %NsoCsvCapcher->{err_code};
	# ̓G[̏
	if ($ResultCode == 1) {
		push(@ErrorData, $filename1);
		push(@ErrorMessage, "t@C܂B");
		$ErrorCode = $csv_analyzeing_error;
		html_out( "NG" , $ErrorCode );
	}
	
	# "UpdateSeparatelyPointHistory.csv"̉
	%NsoCsvCapcher = NsoCsvCapcher->NsoCsvCapcher($csv_pass, $filename2);
	my $NsoCsvCapcher_UpSeparatePoint = %NsoCsvCapcher->{datalist};
	$ResultCode = %NsoCsvCapcher->{err_code};
	# ̓G[̏
	if ($ResultCode == 1) {
		push(@ErrorData, $filename2);
		push(@ErrorMessage, "t@C܂B");
		$ErrorCode = $csv_analyzeing_error;
		html_out( "NG" , $ErrorCode );
	}

#-------------

	# DBڑ(G[̎̓bZ[Wݐϊi[Areturn/SQL{G[ʂɑJ)
	my $connectError = $DbConnect->DbConnect();
	if ( $connectError ne "" ){
		push(@ErrorData, "");
		push(@ErrorMessage, "f[^x[XڑɃG[܂B");
		$ErrorCode = $db_connect_error;
		html_out( "NG" , $ErrorCode );
	}

#-------------f[^ʍXV, |Cg폜
	# NG쐬
	my %sqlesc = ();
	## 1sPʂł̃f[^WJEDBǉ(tB[hf[^EnbVWJ)
	foreach my $CsvCap_Line ( @$NsoCsvCapcher_UpSeparateMember ) {
		foreach my $key ( sort keys %$CsvCap_Line ) {
			# SJISEUCGR[hGXP[v
			$sqlesc{$key} = $DbConnect->Sql_Escape_sjis2euc_decode($$CsvCap_Line{$key});
		}
		
		   # 20100223 Y.Motai start
        
    #-------------f[^ʍ폜
		my %RecordHash4 = (
			SamePeriodID	=>	$sqlesc{'SamePeriodID'},		# ID
		);

		# NGs
		$SQL_query4 = $NsoSyncRelayCall->Del_Customer_relayQuery(\%RecordHash4);

		my %db4;
		%db4 = $DbConnect->DbDelete($SQL_query4);
		# SQL ʎ擾(G[̎̓bZ[Wݐϊi[AHtml_out)
		$rows = %db4->{rows};
		my $queryError = %db4->{status_err};
		if ( $queryError ne ""){
			push(@ErrorData, "$$CsvCap_Line{SamePeriodID}");
			push(@ErrorMessage, "f[^폜ɃG[܂B");
			$ErrorCode = $member_one_modify_error;
		}
    #-------------f[^ʒǉ
        
        # ̊֐͖{f[^SXVpInsertł邪AŎgp
        # ߂ɓ֐Rs[đ₷͈̂ӖȂ̂őSXVp̂gpĂB
		$SQL_query = $NsoSyncRelayCall->Insert_All_Member_relayQuery(\%sqlesc);
		# $SQL_query = $NsoSyncRelayCall->Member_update_seperate_relayQuery(\%sqlesc);
		
		# NGs
		my %db;
		%db = $DbConnect->DbInsert($SQL_query);
		# %db = $DbConnect->DbUpdate($SQL_query);
		
		# 20100223 Y.Motai end				

		# SQL ʎ擾(G[̎̓bZ[Wݐϊi[AHtml_out)
		$rows = %db->{rows};
		my $queryError = %db->{status_err};
		if ( $queryError ne "" || $rows eq '0E0'){           # '0' => '0E0'
			push(@ErrorData, "$$CsvCap_Line{SamePeriodID}");
			push(@ErrorData2, "$$CsvCap_Line{SamePeriodID}");	 # ǉ鎞g
			push(@ErrorMessage, "f[^ʍXVɃG[܂B");
			$ErrorCode = $member_one_modify_error;
		}
		
	#-------------|Cg폜
		my %RecordHash = (
			SamePeriodID	=>	$sqlesc{'SamePeriodID'},		# ID
		);

		# NGs
		$SQL_query2 = $NsoSyncRelayCall->Del_point_relayQuery(\%RecordHash);

		my %db2;
		%db2 = $DbConnect->DbDelete($SQL_query2);
		# SQL ʎ擾(G[̎̓bZ[Wݐϊi[AHtml_out)
		$rows = %db2->{rows};
		my $queryError = %db2->{status_err};
		if ( $queryError ne ""){
			push(@ErrorData, "$$CsvCap_Line{SamePeriodID}");
			push(@ErrorMessage, "|Cg폜ɃG[܂B");
			$ErrorCode = $member_one_modify_error;
		}
	}
#-------------

#-------------|Cgǉ([|Cg폜]NGɎsꂽꍇ̂)
	# NG쐬
	my %sqlesc = ();

	## 1sPʂł̃f[^WJEDBǉ(tB[hf[^EnbVWJ)
	foreach my $CsvCap_Line ( @$NsoCsvCapcher_UpSeparatePoint ) {
		foreach my $key ( sort keys %$CsvCap_Line ) {
			# SJISEUCGR[hGXP[v
			$sqlesc{$key} = $DbConnect->Sql_Escape_sjis2euc_decode($$CsvCap_Line{$key});
		}

		my %RecordHash2 = (
			SamePeriodID			=>	$sqlesc{'SamePeriodID'},	# ID
			ChangeTime				=>	$sqlesc{'ChangeTime'},		# s(ύX)
			ChangeType				=>	$sqlesc{'ChangeType'},		# ύX敪
			ChangePoint				=>	$sqlesc{'ChangePoint'},		# ύX|Cg
		);

		my $error = 0;
		foreach my $Error_list ( @ErrorData2 ) {			# $Error_list => G[ID
			if ( $Error_list eq $$CsvCap_Line{SamePeriodID} ) {
				$error = 1;
				last;
			}
		}
		unless ( $error ) {			# $error => 0̏ꍇ
			# NGs
			$SQL_query3 = $NsoSyncRelayCall->Point_add_relayQuery(\%RecordHash2);

			my %db3;
			%db3 = $DbConnect->DbInsert($SQL_query3);
			# SQL ʎ擾(G[̎̓bZ[Wݐϊi[AHtml_out)
			$rows = %db3->{rows};
			my $queryError = %db3->{status_err};
			if ( $queryError ne "" || $rows eq '0E0'){           # '0' => '0E0'
				push(@ErrorData, "$$CsvCap_Line{SamePeriodID}");
				push(@ErrorMessage, "|CgǉɃG[܂B");
				$ErrorCode = $member_one_modify_error;
			}
		}
	}
#-------------

	# ʂ̏o
	if ( $ErrorCode ne "" ){
		html_out( "NG" , $ErrorCode );
	} else {
		html_out( "OK" , $ErrorCode );
	}
}


;# 
;# f[^SXV
;# FȂ
;# ߂lFȂ
sub member_all_up_csv_reflection{
	
	my $self = shift;
	my $SQL_query;
	my $SQL_query2;
	my $SQL_query3;
	my $SQL_query4;
	my $rows;
	
	# r`FbN (rJn)
	$LockFlag = lock_cgi();

#-------------CSV
	# ͑Ȍ
	my %NsoCsvCapcher;
	my $ResultCode;

	# "UpdateAllMemberData.csv"̉
	%NsoCsvCapcher = NsoCsvCapcher->NsoCsvCapcherDecode($csv_pass, $filename1);
	my $NsoCsvCapcher_UpAllMember = %NsoCsvCapcher->{datalist};
	$ResultCode = %NsoCsvCapcher->{err_code};
	# ̓G[̏
	if ($ResultCode == 1) {
		push(@ErrorData, $filename1);
		push(@ErrorMessage, "t@C܂B");
		$ErrorCode = $csv_analyzeing_error;
		html_out( "NG" , $ErrorCode );
	}
	
	# "UpdateAllPointHistory.csv"̉
	%NsoCsvCapcher = NsoCsvCapcher->NsoCsvCapcher($csv_pass, $filename2);
	my $NsoCsvCapcher_UpAllPoint = %NsoCsvCapcher->{datalist};
	$ResultCode = %NsoCsvCapcher->{err_code};
	# ̓G[̏
	if ($ResultCode == 1) {
		push(@ErrorData, $filename2);
		push(@ErrorMessage, "t@C܂B");
		$ErrorCode = $csv_analyzeing_error;
		html_out( "NG" , $ErrorCode );
	}

#-------------

	# DBڑ(G[̎̓bZ[Wݐϊi[Areturn/SQL{G[ʂɑJ)
	my $connectError = $DbConnect->DbConnect();
	if ( $connectError ne "" ){
		push(@ErrorData, "");
		push(@ErrorMessage, "f[^x[XڑɃG[܂B");
		$ErrorCode = $db_connect_error;
		html_out( "NG" , $ErrorCode );
	}

#-------------f[^S폜̍쐬
	# NG쐬
	$SQL_query = $NsoSyncRelayCall->Del_All_Member_relayQuery();

	# NGs
	my %db;
	%db = $DbConnect->DbDelete($SQL_query);
	# SQL ʎ擾(G[̎̓bZ[Wݐϊi[AHtml_out)
	my $queryError = %db->{status_err};
	if ( $queryError ne ""){
		push(@ErrorData, "");
		push(@ErrorMessage, "f[^S폜ɃG[܂B");
		$ErrorCode = $member_all_modify_error;
		html_out( "NG" , $ErrorCode );
	}
#-------------

#-------------|CgS폜̍쐬
	# NG쐬
	$SQL_query2 = $NsoSyncRelayCall->Del_All_Point_relayQuery();

	# NGs
	my %db2;
	%db2 = $DbConnect->DbDelete($SQL_query2);
	# SQL ʎ擾(G[̎̓bZ[Wݐϊi[AHtml_out)
	my $queryError = %db2->{status_err};
	if ( $queryError ne ""){
		push(@ErrorData, "");
		push(@ErrorMessage, "|CgS폜ɃG[܂B");
		$ErrorCode = $member_all_modify_error;
	}
#-------------

#-------------f[^ǉ
	my %sqlesc = ();

	## 1sPʂł̃f[^WJEDBǉ(tB[hf[^EnbVWJ)
	foreach my $CsvCap_Line ( @$NsoCsvCapcher_UpAllMember ) {
		foreach my $key ( sort keys %$CsvCap_Line ) {
			# SJISEUCGR[hGXP[v
			$sqlesc{$key} = $DbConnect->Sql_Escape_sjis2euc_decode($$CsvCap_Line{$key});
		}

	#-------------f[^ǉ̍쐬
		# NG쐬
		$SQL_query3 = $NsoSyncRelayCall->Insert_All_Member_relayQuery(\%sqlesc);

		# NGs
		my %db3;
		%db3 = $DbConnect->DbInsert($SQL_query3);
		# SQL ʎ擾(G[̎̓bZ[Wݐϊi[AHtml_out)
		$rows = %db3->{rows};
		my $queryError = %db3->{status_err};
		if ( $queryError ne "" || $rows eq '0E0'){           # '0' => '0E0'
			push(@ErrorData, "$$CsvCap_Line{SamePeriodID}");
			push(@ErrorMessage, "f[^ǉɃG[܂B");
			$ErrorCode = $member_all_modify_error;
		}
	}
#-------------

#-------------|Cgǉ
	my %sqlesc = ();

	## 1sPʂł̃f[^WJEDBǉ(tB[hf[^EnbVWJ)
	foreach my $CsvCap_Line ( @$NsoCsvCapcher_UpAllPoint ) {
		foreach my $key ( sort keys %$CsvCap_Line ) {
			# SJISEUCGR[hGXP[v
			$sqlesc{$key} = $DbConnect->Sql_Escape_sjis2euc_decode($$CsvCap_Line{$key});
		}

	#-------------|Cgǉ̍쐬
		my %RecordHash = (
			SamePeriodID			=>	$sqlesc{'SamePeriodID'},	# ID
			ChangeTime				=>	$sqlesc{'ChangeTime'},		# s(ύX)
			ChangeType				=>	$sqlesc{'ChangeType'},		# ύX敪
			ChangePoint				=>	$sqlesc{'ChangePoint'},		# ύX|Cg
		);
		# NG쐬
		$SQL_query4 = $NsoSyncRelayCall->Point_add_relayQuery(\%RecordHash);

		# NGs
		my %db4;
		%db4 = $DbConnect->DbInsert($SQL_query4);
		# SQL ʎ擾(G[̎̓bZ[Wݐϊi[AHtml_out)
		$rows = %db4->{rows};
		my $queryError = %db4->{status_err};
		if ( $queryError ne "" || $rows eq '0E0'){           # '0' => '0E0'
			push(@ErrorData, "$$CsvCap_Line{SamePeriodID}");
			push(@ErrorMessage, "|CgǉɃG[܂B");
			$ErrorCode = $member_all_modify_error;
		}
	}
#-------------

	# ʂ̏o
	if ( $ErrorCode ne "" ){
		html_out( "NG" , $ErrorCode );
	} else {
		html_out( "OK" , $ErrorCode );
	}
}


;# 
;# HTTPX|X
;# Fʁi$Resultj
;#     FG[R[hi$ErrorCodej
;# ߂lFȂ
sub html_out{
	my ( $Result , $ErrorCode ) = @_;
	my $Message_Split;

	print "Content-Type:text/html; charset=Shift_JIS\n\n";
	print "<TABLE>\n";
	print "  <TR>\n";
	print "    <TD>$Result</TD>\n";
	print "    <TD>error_codeF$ErrorCode</TD>\n";
	print "  </TR>\n";
	print "  <TR>\n";
	foreach $Message_Split ( @ErrorData ) {
		print "<TD>$Message_Split</TD>\n";
	}
	print "  </TR>\n";
	print "  <TR>\n";
	foreach $Message_Split ( @ErrorMessage ) {
		print "<TD>$Message_Split</TD>\n";
	}
	print "  </TR>\n";
	print "</TABLE>\n";

	# r
	$LockFlag = unlock_cgi();
	exit;
}

;# 
;# rJn (dbgw_relay.cgidN}~̂)
;# ߂lF 0:rs 1:r
;# 
sub lock_cgi {

	# bNpfBNg
	my $dir = $LockDir =~ /\/$/ ? "$LockDir$Lock" : "$LockDir/$Lock";
	
	# bNpfBNgŏIXVő働bN(b)o߂Ăꍇ͍폜
	if ( -d $dir && ( -M $dir ) * 86400 > $LockLimit ) {
		rmdir( $dir );
	}
	
	# bNpfBNg쐬 (0:s 1:)
	if ( !mkdir( $dir , 0755 ) ) {
		$ErrorCode = $duplicate_startup_error;	# dNG[
		push(@ErrorData, "");
		push(@ErrorMessage, "dNG[");
		&html_out( "NG" , $ErrorCode );
	}
	return 1;	# bNJn
}

;# 
;# r (dbgw_relay.cgidN}~̂)
;# ߂lF 0
;# 
sub unlock_cgi {

	# bNpfBNg
	my $dir = $LockDir =~ /\/$/ ? "$LockDir$Lock" : "$LockDir/$Lock";

	# bN̏ꍇ̓bNpfBNg폜
	if ( $LockFlag == 1 && -d $dir ) {
		rmdir( $dir );
	}
	return 0;	# bN
}













